  GET	stm32f103C8.asm
Stack_Size    EQU   0x400
top_of_stack  EQU 0x20000000 + Stack_Size

  PRESERVE8
  THUMB
  
  AREA	RESET,	DATA, READONLY
  DCD   top_of_stack  ;Top of Stack
  DCD   Start
  
	DCD     int_vect_terminator
	DCD     int_vect_terminator
	DCD     int_vect_terminator
	DCD     int_vect_terminator
	DCD     int_vect_terminator
	DCD     0
	DCD     0
	DCD     0
	DCD     0
	DCD     int_vect_terminator
	DCD     int_vect_terminator
	DCD     0
	DCD     int_vect_terminator
	DCD     ISR_SYSTICK

  AREA  |.text|, CODE, READONLY
   
  EXTERN RCC_DEINIT
  EXTERN SYSCLK72_START
  EXTERN SYSTICK_START
  EXTERN ISR_SYSTICK
  EXTERN SYSTICK_DELAY

  ENTRY

int_vect_terminator
	B	int_vect_terminator
 
Start    PROC
  BL    RCC_DEINIT

  MOV   R0, #0
  MOV   R1, #1

  ;Alternate Function I/O clock enable
  LDR   R2, =(PERIPH_BB_BASE + (RCC_APB2ENR - PERIPH_BASE) * 32 + RCC_APB2ENR_AFIOEN_N * 4)
  STR   R1, [R2]
  ;Delay after clock enabling
  LDR   R2, [R2]

  ;NOJTAG: JTAG-DP Disabled and SW-DP Enabled 
  LDR   R2, =AFIO_MAPR
  LDR   R3, [R2]
  BIC   R3, R3, #AFIO_MAPR_SWJ_CFG
  STR   R3, [R2]
  ;Set bit AFIO_MAPR_SWJ_CFG_JTAGDISABLE in register AFIO_MAPR
  LDR   R2, =(PERIPH_BB_BASE + (AFIO_MAPR - PERIPH_BASE) * 32 + AFIO_MAPR_SWJ_CFG_JTAGDISABLE_N * 4)
  STR   R1, [R2]

  BL    SYSCLK72_START
  BL    SYSTICK_START

  LDR   R2, =(PERIPH_BB_BASE + (RCC_APB2ENR - PERIPH_BASE) * 32 + RCC_APB2ENR_IOPCEN_N * 4)
  STR   R1, [R2]
  
  LDR   R2, =(PERIPH_BB_BASE + (GPIOC_CRH - PERIPH_BASE) * 32 + GPIO_CRH_MODE13_0_N * 4)
  STR   R1, [R2]
  
  LDR   R2, =(PERIPH_BB_BASE + (GPIOC_ODR - PERIPH_BASE) * 32 + GPIO_ODR_ODR13_N * 4)
  STR   R1, [R2]

loop
  STR   R0, [R2]
  BL    DELAY
  STR   R1, [R2]
  BL    DELAY
  B     loop

  ENDP

DELAY    PROC
  PUSH 	{R0, LR}
  MOV	  R0, #500
  BL    SYSTICK_DELAY
  POP 	{R0, PC}
  ENDP

  ALIGN
  END