	GET	stm32f103C8.asm
  AREA __clk,CODE,READONLY
    
RCC_DEINIT  PROC
  PUSH  {R0, R1, R2, R3, LR}
  MOV   R0, #0
  MOV   R1, #1

  ;HSI On
  LDR   R2, =(PERIPH_BB_BASE + (RCC_CR - PERIPH_BASE) * 32 + RCC_CR_HSION_N * 4)
  STR   R1, [R2]

  LDR   R2, =RCC_CR
wait_hsirdy
  LDR   R3,[R2]         ; читаем регистр RCC_CR
  TST   R3,#(1<<RCC_CR_HSIRDY_N)
  BEQ   wait_hsirdy

  ;Reset internal high-speed clock trimming
  LDR   R3, [R2]
  BIC   R3, R3, #RCC_CR_HSITRIM
  ORR   R3, R3, #0x80
  STR   R3, [R2]

  ;Clear RCC_CFGR
  LDR   R2, =RCC_CFGR
  STR   R0, [R2]

  LDR   R2, =RCC_CFGR
wait_cfgrsws
  LDR   R3,[R2]         ; читаем регистр RCC_CFGR
  AND   R3, R3, #RCC_CFGR_SWS
  CMP   R3, #0
  BNE   wait_cfgrsws

  ;Clear bit RCC_CR_PLLON in register RCC_CR
  LDR   R2, =(PERIPH_BB_BASE + (RCC_CR - PERIPH_BASE) * 32 + RCC_CR_PLLON_N * 4)
  STR   R0, [R2]
 
  LDR   R2, =RCC_CR
wait_pllrdy_res
  LDR   R3,[R2]         ; читаем регистр RCC_CR
  AND   R3, R3, #RCC_CR_PLLRDY
  CMP   R3, #0
  BNE   wait_pllrdy_res

  ;Clear bits RCC_CR_HSEON and RCC_CR_CSSON in register RCC_CR
  LDR   R3, [R2]
  BIC   R3, R3, #(RCC_CR_HSEON + RCC_CR_CSSON)
  STR   R3, [R2]
 
wait_hserdy_res
  LDR   R3,[R2]         ; читаем регистр RCC_CR
  AND   R3, R3, #RCC_CR_HSERDY
  CMP   R3, #0
  BNE   wait_hserdy_res

  ;Clear bit RCC_CR_HSEBYP in register RCC_CR
  LDR   R2, =(PERIPH_BB_BASE + (RCC_CR - PERIPH_BASE) * 32 + RCC_CR_HSEBYP_N * 4)
  STR   R0, [R2]

  ;Reset all CSR flags
  LDR   R2, =(PERIPH_BB_BASE + (RCC_CSR - PERIPH_BASE) * 32 + RCC_CSR_RMVF_N * 4)
  STR   R1, [R2]

  POP   {R0, R1, R2, R3, PC}
  ENDP

SYSCLK72_START  PROC
  PUSH  {R0, R1, R2, R3, LR}

  MOV   R0, #0
  MOV   R1, #1

  LDR   R2, =(PERIPH_BB_BASE + (RCC_CR - PERIPH_BASE) * 32 + RCC_CR_HSEON_N * 4)
  STR   R1, [R2]
 
  LDR   R2, =RCC_CR
wait_hserdy
  LDR   R3,[R2]         ; читаем регистр RCC_CR
  TST   R3,#(1<<RCC_CR_HSERDY_N)
  BEQ   wait_hserdy

  ;Enable the Prefetch Buffer
  ;Clear and set bit FLASH_ACR_PRFTBE in register FLASH_ACR
  LDR   R2, =(PERIPH_BB_BASE + (FLASH_ACR - PERIPH_BASE) * 32 + FLASH_ACR_PRFTBE_N * 4)
  STR   R0, [R2]
  STR   R1, [R2]
  
  ;Clear field of bits FLASH_ACR_LATENCY in register FLASH_ACR
  LDR   R2, =FLASH_ACR
  LDR   R3, [R2]
  BIC   R3, R3, #FLASH_ACR_LATENCY
  STR   R3, [R2]
  ;Set bit FLASH_ACR_LATENCY_2 in register FLASH_ACR
  LDR   R2, =(PERIPH_BB_BASE + (FLASH_ACR - PERIPH_BASE) * 32 + FLASH_ACR_LATENCY_2_N * 4)
  STR   R1, [R2]

  ;Clear field of bits RCC_CFGR_HPRE in register RCC_CFGR
  ;DIV1
  LDR   R2, =RCC_CFGR
  LDR   R3, [R2]
  BIC   R3, R3, #RCC_CFGR_HPRE
  STR   R3, [R2]
  ;Clear field of bits RCC_CFGR_PPRE2 in register RCC_CFGR
  ;DIV1
  LDR   R3, [R2]
  BIC   R3, R3, #RCC_CFGR_PPRE2
  STR   R3, [R2]
  ;Clear field of bits RCC_CFGR_PPRE1 in register RCC_CFGR
  LDR   R3, [R2]
  BIC   R3, R3, #RCC_CFGR_PPRE2
  STR   R3, [R2]
  ;DIV2
  LDR   R3, [R2]
  ORR   R3, R3, #RCC_CFGR_PPRE1_DIV2
  STR   R3, [R2]
  LDR   R3, [R2]
  BIC   R3, R3, #RCC_CFGR_PPRE2
  STR   R3, [R2]

  ;Clear bits RCC_CFGR_PLLXTPRE and RCC_CFGR_PLLMULL in register RCC_CFGR
  LDR   R3, [R2]
  BIC   R3, R3, #(RCC_CFGR_PLLXTPRE + RCC_CFGR_PLLMULL)
  STR   R3, [R2]
  ;Set bits RCC_CFGR_PLLSRC and RCC_CFGR_PLLMULL9 in register RCC_CFGR
  LDR   R3, [R2]
  ORR   R3, R3, #(RCC_CFGR_PLLSRC + RCC_CFGR_PLLMULL9)
  STR   R3, [R2]

  ;Set bit RCC_CR_PLLON in register RCC_CR
  LDR   R2, =(PERIPH_BB_BASE + (RCC_CR - PERIPH_BASE) * 32 + RCC_CR_PLLON_N * 4)
  STR   R1, [R2]
 
  LDR   R2, =RCC_CR
wait_pllrdy
  LDR   R3,[R2]         ; читаем регистр RCC_CR
  TST   R3,#RCC_CR_PLLRDY
  BEQ   wait_pllrdy

  ;Clear field of bits RCC_CFGR_SW in register RCC_CFGR
  LDR   R2, =RCC_CFGR
  LDR   R3, [R2]
  BIC   R3, R3, #RCC_CFGR_SW
  STR   R3, [R2]
  ;Set bit RCC_CFGR_SW_PLL in register RCC_CFGR
  LDR   R3, [R2]
  ORR   R3, R3, #RCC_CFGR_SW_PLL
  STR   R3, [R2]
 
  ;while(READ_BIT(RCC->CFGR, RCC_CFGR_SWS) != RCC_CFGR_SWS_PLL) {}
wait_swsrdy
  LDR   R3,[R2]         ; читаем регистр RCC_CFGR
  TST   R3,#RCC_CFGR_SWS
  BEQ   wait_swsrdy

  POP   {R0, R1, R2, R3, PC}
  ENDP

  ALIGN
  
  EXPORT RCC_DEINIT
  EXPORT SYSCLK72_START
 
  END